<?php

namespace Teknisa\CRM\Util;

use Zeedhi\Framework\Session\Session;


class CRMParameters{

    protected $session;

    public function __construct(Session $session, $paramService) {
        $this->session = $session;
        $this->paramService = $paramService;
    }

    /**
     * @return String
     */
    public function getUserId() {
        return $this->session->get("operator");
    }

    /**
     * @return Integer
     */
    public function getOrganizationId() {
        return $this->session->get("nrorg");
    }

    public function setUserId($userId) {
        $this->session->set("operator", $userId);
    }

    public function setOrganizationId($organizationId) {
        $this->session->set("nrorg", $organizationId);
    }

    /**
     * @return \DateTime
     */
    public function getCurrentTime() {
        return new \DateTime();
    }

    /**
     * @return Integer
     */
    public function getProjectId() {
        return 13;
    }

    /**
     * @return String
     */
    public function getProjectUniqueId() {
        return "P_13";
    }

    /**
     * Return a array of directories which have containers
     * @return Array
     */
    public function getJsonsDirectories() {
        return array(realpath(__DIR__."/../../../mobile/json/containers"));
    }

    /**
     * Return the way for the containers.json file
     * @return String
     */
    public function getContainersJsonPath() {
        return realpath(__DIR__."/../../../mobile/json/containers.json");
    }
    
    public function returnParamsSmtp(){
        
        $userName = null;
        $passWord = null;
        $host = null;
        $port = null;
        $SMTPSecure = null;
        
        $paramOrg = $this->paramService->callGetCrmParametrization(array('NRORG' => $this->getNrorg()));
        
        if(isset($paramOrg[0])){
           $paramOrg = $paramOrg[0];
           $userName = $paramOrg["DSEMAILSMTP"] ? $paramOrg["DSEMAILSMTP"] : $userName;
           $passWord = $paramOrg["DSSENHASMTP"] ? $paramOrg["DSSENHASMTP"] : $passWord;
           $host = $paramOrg["DSHOSTSMTP"] ? $paramOrg["DSHOSTSMTP"] : $host;
           $port = $paramOrg["DSPORTASMTP"] ? $paramOrg["DSPORTASMTP"] : $port;
           $SMTPSecure = $paramOrg["IDSMTPSECURE"] ? $paramOrg["IDSMTPSECURE"] : $SMTPSecure;
        }
        
        $params = array('host' => $host, 'username' => $userName, 'password' => $passWord, 'port' => $port, 'from' => $userName, 'smtpSecure' => $SMTPSecure);
        
        return $params;    
    }
    
    public function getNrorgTrabalho() {
        $value = $this->session->get('CRM_NRORGTRAB');
        return $value;
    }
    
    public function changeSessionParam($param, $value) {
        $this->session->set($param, $value);
    }
    
    public function getNrorg() {
        $value = $this->session->get('NRORG');
        return $value;
    }
    
}