function MotiEvolcontController(ScreenService, templateManager, Utilities, wizardEngine, ZHPromise, Operador_Repository, General, CRM_Utilities, restEngine, ChamadoController, evolutionTabController, ZHPromise) {

    /**
     * Função para abrir a widget de seleção
     * de arquivos.
    */
    this.openAttachPopup = function(){
        
        var fileUploadWidget = templateManager.container.getWidget('WDGT_SELECAO_ARQUIVOS');
        ScreenService.openPopup(fileUploadWidget);
            
    };
    
    /**
     * Função para fechar o Popup de upload de imagens.
     * 
     * @param {object} widget widget de upload de imagens.
    */
    this.closeAttachPopup = function(widget){
        ScreenService.closePopup();
        widget.isVisible = false;
        widget.parent.parent.view();
        widget.parent.parent.activate();
    };
    
    /**
     * Função para fazer o download de um arquivo
     * salvo no servidor.
     * 
     * @param {object} widget widget que contém
     * as informações do arquivo a ser baixado 
     * em sua currentRow.
    */    
    this.downloadFile = function(widget){
        
        window.open(window.fileServerBaseUrl + widget.currentRow.DSCAMINHOANEXOPADRAO);
            
    };
    
    this.changeActionDefaultAttachment = function(widget){
        var currentRow = widget.currentRow;
        
        if(Util.isEmptyOrBlank(currentRow.DSCAMINHOANEXOPADRAO) && Util.isEmptyOrBlank(currentRow.ATTACHMENT)){
            widget.getAction('DOWNLOAD').isVisible = false;
            widget.getAction('REMOVE_FILE').isVisible = false;
            widget.getAction('UPLOAD').isVisible = true;
            widget.getAction('UPLOAD').label = 'Adicionar anexo padrão';
        }else{
            widget.getAction('DOWNLOAD').isVisible = true;
            widget.getAction('REMOVE_FILE').isVisible = true;
            widget.getAction('UPLOAD').isVisible = true;
            widget.getAction('UPLOAD').label = 'Modificar anexo padrão';
        }
        
        widget.activate();
    };
    
    
    /**
     * Seta o anexo na widget de motivo e salva.
    */
    this.uploadDefaultFile = function(widget){
        widget.parent.parent.currentRow.ATTACHMENT = widget.currentRow.DSCAMINHO;
        
        General.widgetSave(widget.parent.parent).then(function(){
            ScreenService.showMessage('Anexo salvo com sucesso!');
            this.closeAttachPopup(widget);
            this.changeActionDefaultAttachment(widget.parent.parent);
            widget.parent.parent.reload();    
        }.bind(this));
    };
    
    this.askToRemoveFile = function(widget) {
        var message = 'Deseja realmente remover o anexo padrão?';
        
        ScreenService.confirmMessage(message, 'question', () => this.removeFile(widget));
    };
    
    this.removeFile = function(widget) {
        var params = {
            requestType: 'Row',
            row: widget.currentRow
        };
        
        CRM_Utilities.post('/removeMotiEvolAttachment', params).then(response => {
            widget.reload().then(() => {
                widget.currentRow.ATTACHMENT = null;
                
                ScreenService.closePopup();
                this.changeActionDefaultAttachment(widget);
                ScreenService.showMessage('Anexo removido com sucesso!');
            });
        });
    };
}

Configuration(function(ContextRegister) {
    ContextRegister.register('MotiEvolcontController', MotiEvolcontController);
});